
/* MotoCoder_DataStore.h */
/* Generated by MotoCoder */
/* Version: 0.12.4 */
/* At: 2012-02-21 18:20:11 */
/* Copyright: 2012 Woodward. */


#ifndef MOTOCODER_DATASTORE_H
#define MOTOCODER_DATASTORE_H



#include <MotoCoder.h>
	


/*---- DEFINES --------------------------------------------------------------------------------------------*/

#define NON_VOLATILE_OVERHEAD_BYTES     (4 + 4)
    
  
/*---- TYPEDEFS -------------------------------------------------------------------------------------------*/

/* Name: E_NVStatus ClassID:ENUMDEC EnumDflt:"Illegal" */
typedef enum
{
  NV_LOADING_FACTORY,                   /* EnumTxt:"Currently loading NV from Factory FLASH to RAM" */
  NV_LOADING_EEPROM,                    /* EnumTxt:"Currently loading NV from EEPROM to RAM" */
  NV_STORING_EEPROM,                    /* EnumTxt:"Currently storing NV from RAM to EEPROM" */
  NV_LOADED_FACTORY_BAD_MAGIC,          /* EnumTxt:"Detected new program.  Loaded Factory Defaults from FLASH" */
  NV_LOADED_FACTORY_BAD_CRC,            /* EnumTxt:"CRC failure.  Loaded Factory Defaults from FLASH" */
  NV_LOADED_FACTORY_USER_CMD,           /* EnumTxt:"User requested refresh from Factory Defaults in FLASH." */
  NV_LOADED_EEPROM                      /* EnumTxt:"Successful refresh of EEPROM values from last shutdown" */
} E_NVStatus;

/* Name: E_NVRestore ClassID:ENUMDEC EnumDflt:"Illegal" */
typedef enum
{
  NV_RESTORE_APP,                       /* EnumTxt:"Load saved application values on next startup" */
  NV_RESTORE_DEFAULTS,                  /* EnumTxt:"Load factory defaults on next startup" */
} E_NVRestore;

typedef struct S_NVEEStatus
{
    uint8_T RestoreOnStartup;
    uint8_T RestoreOnFirstStartup;
}S_NVEEStatus;



     

/* NonVolatile namespace */
typedef struct {
    uint32_T NonVolatileFormatID;
    uint32_T crc;
    uint32_T   MotoHawkModelSecondsInUse;
    uint8_T   CityID_CAN_1;

} NonVolatile_T;
#define MotoHawkModelSecondsInUse_DataStore_BYTES() (sizeof(MotoHawkModelSecondsInUse_DataStore()))
#define MotoHawkModelSecondsInUse_DataStore_ELEMS() (1 * 1)
#define MotoHawkModelSecondsInUse_DataStore_ROWS() (1)
#define MotoHawkModelSecondsInUse_DataStore_COLS() (1)
#define MotoHawkModelSecondsInUse_DataStore()  (NonVolatileWork.MotoHawkModelSecondsInUse)

#define CityID_CAN_1_DataStore_BYTES() (sizeof(CityID_CAN_1_DataStore()))
#define CityID_CAN_1_DataStore_ELEMS() (1 * 1)
#define CityID_CAN_1_DataStore_ROWS() (1)
#define CityID_CAN_1_DataStore_COLS() (1)
#define CityID_CAN_1_DataStore()  (NonVolatileWork.CityID_CAN_1)


/* constants namespace */
typedef struct {
    uint16_T   ECUP_Threshold;

} Constant_T;
#define ECUP_Threshold_DataStore_BYTES() (sizeof(ECUP_Threshold_DataStore()))
#define ECUP_Threshold_DataStore_ELEMS() (1 * 1)
#define ECUP_Threshold_DataStore_ROWS() (1)
#define ECUP_Threshold_DataStore_COLS() (1)
#define ECUP_Threshold_DataStore()  (ConstantWork.ECUP_Threshold)


	/* volatile namespace */
	typedef struct {
	    real32_T   Floor;
    real32_T   Scaling;
    real32_T   ValueFont;
    real32_T   ValueX;
    real32_T   ValueY;
    real32_T   rect0Y0;
    real32_T   rect0Y1;
    real32_T   rect1Fill;
    real32_T   rect1Line;
    real32_T   rect1X0;
    real32_T   rect1X1;
    real32_T   rect1Y1;
    real32_T   value;
    uint8_T   string_ov_new[18];

	} Volatile_T;
#define Floor_DataStore_BYTES() (sizeof(Floor_DataStore()))
#define Floor_DataStore_ELEMS() (1 * 1)
#define Floor_DataStore_ROWS() (1)
#define Floor_DataStore_COLS() (1)
#define Floor_DataStore()  (VolatileWork.Floor)

#define Scaling_DataStore_BYTES() (sizeof(Scaling_DataStore()))
#define Scaling_DataStore_ELEMS() (1 * 1)
#define Scaling_DataStore_ROWS() (1)
#define Scaling_DataStore_COLS() (1)
#define Scaling_DataStore()  (VolatileWork.Scaling)

#define ValueFont_DataStore_BYTES() (sizeof(ValueFont_DataStore()))
#define ValueFont_DataStore_ELEMS() (1 * 1)
#define ValueFont_DataStore_ROWS() (1)
#define ValueFont_DataStore_COLS() (1)
#define ValueFont_DataStore()  (VolatileWork.ValueFont)

#define ValueX_DataStore_BYTES() (sizeof(ValueX_DataStore()))
#define ValueX_DataStore_ELEMS() (1 * 1)
#define ValueX_DataStore_ROWS() (1)
#define ValueX_DataStore_COLS() (1)
#define ValueX_DataStore()  (VolatileWork.ValueX)

#define ValueY_DataStore_BYTES() (sizeof(ValueY_DataStore()))
#define ValueY_DataStore_ELEMS() (1 * 1)
#define ValueY_DataStore_ROWS() (1)
#define ValueY_DataStore_COLS() (1)
#define ValueY_DataStore()  (VolatileWork.ValueY)

#define rect0Y0_DataStore_BYTES() (sizeof(rect0Y0_DataStore()))
#define rect0Y0_DataStore_ELEMS() (1 * 1)
#define rect0Y0_DataStore_ROWS() (1)
#define rect0Y0_DataStore_COLS() (1)
#define rect0Y0_DataStore()  (VolatileWork.rect0Y0)

#define rect0Y1_DataStore_BYTES() (sizeof(rect0Y1_DataStore()))
#define rect0Y1_DataStore_ELEMS() (1 * 1)
#define rect0Y1_DataStore_ROWS() (1)
#define rect0Y1_DataStore_COLS() (1)
#define rect0Y1_DataStore()  (VolatileWork.rect0Y1)

#define rect1Fill_DataStore_BYTES() (sizeof(rect1Fill_DataStore()))
#define rect1Fill_DataStore_ELEMS() (1 * 1)
#define rect1Fill_DataStore_ROWS() (1)
#define rect1Fill_DataStore_COLS() (1)
#define rect1Fill_DataStore()  (VolatileWork.rect1Fill)

#define rect1Line_DataStore_BYTES() (sizeof(rect1Line_DataStore()))
#define rect1Line_DataStore_ELEMS() (1 * 1)
#define rect1Line_DataStore_ROWS() (1)
#define rect1Line_DataStore_COLS() (1)
#define rect1Line_DataStore()  (VolatileWork.rect1Line)

#define rect1X0_DataStore_BYTES() (sizeof(rect1X0_DataStore()))
#define rect1X0_DataStore_ELEMS() (1 * 1)
#define rect1X0_DataStore_ROWS() (1)
#define rect1X0_DataStore_COLS() (1)
#define rect1X0_DataStore()  (VolatileWork.rect1X0)

#define rect1X1_DataStore_BYTES() (sizeof(rect1X1_DataStore()))
#define rect1X1_DataStore_ELEMS() (1 * 1)
#define rect1X1_DataStore_ROWS() (1)
#define rect1X1_DataStore_COLS() (1)
#define rect1X1_DataStore()  (VolatileWork.rect1X1)

#define rect1Y1_DataStore_BYTES() (sizeof(rect1Y1_DataStore()))
#define rect1Y1_DataStore_ELEMS() (1 * 1)
#define rect1Y1_DataStore_ROWS() (1)
#define rect1Y1_DataStore_COLS() (1)
#define rect1Y1_DataStore()  (VolatileWork.rect1Y1)

#define value_DataStore_BYTES() (sizeof(value_DataStore()))
#define value_DataStore_ELEMS() (1 * 1)
#define value_DataStore_ROWS() (1)
#define value_DataStore_COLS() (1)
#define value_DataStore()  (VolatileWork.value)

#define string_ov_new_DataStore_BYTES() (sizeof(string_ov_new_DataStore()))
#define string_ov_new_DataStore_ELEMS() (1 * 18)
#define string_ov_new_DataStore_ROWS() (1)
#define string_ov_new_DataStore_COLS() (18)
#define string_ov_new_DataStore()  (VolatileWork.string_ov_new)


/* volatile (zero initialized) namespace */
typedef struct {
    real32_T   ValuestringFill;
    real32_T   ValuestringLine;
    real32_T   rect0Fill;
    real32_T   rect0Line;
    int16_T   init_resource_DOut1779p0004;
    int16_T   init_resource_ECUP;
    boolean_T   MPRD;
    boolean_T   MPRD_KeepAlive;
    boolean_T   MPRD_new;
    boolean_T   MPRD_ovr;
    boolean_T   ProcessorReboot;
    boolean_T   RestoreNVFactoryDefaults;
    boolean_T   StoreNV;
    boolean_T   ValuehorizCenter;
    boolean_T   ValuevertCenter;
    boolean_T   Valuewrap;
    boolean_T   string_ov_ovr;

} Volatile_BSS_T;

#define ValuestringFill_DataStore_BYTES() (sizeof(ValuestringFill_DataStore()))
#define ValuestringFill_DataStore_ELEMS() (1 * 1)
#define ValuestringFill_DataStore_ROWS() (1)
#define ValuestringFill_DataStore_COLS() (1)
#define ValuestringFill_DataStore()  (VolatileWork_BSS.ValuestringFill)

#define ValuestringLine_DataStore_BYTES() (sizeof(ValuestringLine_DataStore()))
#define ValuestringLine_DataStore_ELEMS() (1 * 1)
#define ValuestringLine_DataStore_ROWS() (1)
#define ValuestringLine_DataStore_COLS() (1)
#define ValuestringLine_DataStore()  (VolatileWork_BSS.ValuestringLine)

#define rect0Fill_DataStore_BYTES() (sizeof(rect0Fill_DataStore()))
#define rect0Fill_DataStore_ELEMS() (1 * 1)
#define rect0Fill_DataStore_ROWS() (1)
#define rect0Fill_DataStore_COLS() (1)
#define rect0Fill_DataStore()  (VolatileWork_BSS.rect0Fill)

#define rect0Line_DataStore_BYTES() (sizeof(rect0Line_DataStore()))
#define rect0Line_DataStore_ELEMS() (1 * 1)
#define rect0Line_DataStore_ROWS() (1)
#define rect0Line_DataStore_COLS() (1)
#define rect0Line_DataStore()  (VolatileWork_BSS.rect0Line)

#define init_resource_DOut1779p0004_DataStore_BYTES() (sizeof(init_resource_DOut1779p0004_DataStore()))
#define init_resource_DOut1779p0004_DataStore_ELEMS() (1 * 1)
#define init_resource_DOut1779p0004_DataStore_ROWS() (1)
#define init_resource_DOut1779p0004_DataStore_COLS() (1)
#define init_resource_DOut1779p0004_DataStore()  (VolatileWork_BSS.init_resource_DOut1779p0004)

#define init_resource_ECUP_DataStore_BYTES() (sizeof(init_resource_ECUP_DataStore()))
#define init_resource_ECUP_DataStore_ELEMS() (1 * 1)
#define init_resource_ECUP_DataStore_ROWS() (1)
#define init_resource_ECUP_DataStore_COLS() (1)
#define init_resource_ECUP_DataStore()  (VolatileWork_BSS.init_resource_ECUP)

#define MPRD_DataStore_BYTES() (sizeof(MPRD_DataStore()))
#define MPRD_DataStore_ELEMS() (1 * 1)
#define MPRD_DataStore_ROWS() (1)
#define MPRD_DataStore_COLS() (1)
#define MPRD_DataStore()  (VolatileWork_BSS.MPRD)

#define MPRD_KeepAlive_DataStore_BYTES() (sizeof(MPRD_KeepAlive_DataStore()))
#define MPRD_KeepAlive_DataStore_ELEMS() (1 * 1)
#define MPRD_KeepAlive_DataStore_ROWS() (1)
#define MPRD_KeepAlive_DataStore_COLS() (1)
#define MPRD_KeepAlive_DataStore()  (VolatileWork_BSS.MPRD_KeepAlive)

#define MPRD_new_DataStore_BYTES() (sizeof(MPRD_new_DataStore()))
#define MPRD_new_DataStore_ELEMS() (1 * 1)
#define MPRD_new_DataStore_ROWS() (1)
#define MPRD_new_DataStore_COLS() (1)
#define MPRD_new_DataStore()  (VolatileWork_BSS.MPRD_new)

#define MPRD_ovr_DataStore_BYTES() (sizeof(MPRD_ovr_DataStore()))
#define MPRD_ovr_DataStore_ELEMS() (1 * 1)
#define MPRD_ovr_DataStore_ROWS() (1)
#define MPRD_ovr_DataStore_COLS() (1)
#define MPRD_ovr_DataStore()  (VolatileWork_BSS.MPRD_ovr)

#define ProcessorReboot_DataStore_BYTES() (sizeof(ProcessorReboot_DataStore()))
#define ProcessorReboot_DataStore_ELEMS() (1 * 1)
#define ProcessorReboot_DataStore_ROWS() (1)
#define ProcessorReboot_DataStore_COLS() (1)
#define ProcessorReboot_DataStore()  (VolatileWork_BSS.ProcessorReboot)

#define RestoreNVFactoryDefaults_DataStore_BYTES() (sizeof(RestoreNVFactoryDefaults_DataStore()))
#define RestoreNVFactoryDefaults_DataStore_ELEMS() (1 * 1)
#define RestoreNVFactoryDefaults_DataStore_ROWS() (1)
#define RestoreNVFactoryDefaults_DataStore_COLS() (1)
#define RestoreNVFactoryDefaults_DataStore()  (VolatileWork_BSS.RestoreNVFactoryDefaults)

#define StoreNV_DataStore_BYTES() (sizeof(StoreNV_DataStore()))
#define StoreNV_DataStore_ELEMS() (1 * 1)
#define StoreNV_DataStore_ROWS() (1)
#define StoreNV_DataStore_COLS() (1)
#define StoreNV_DataStore()  (VolatileWork_BSS.StoreNV)

#define ValuehorizCenter_DataStore_BYTES() (sizeof(ValuehorizCenter_DataStore()))
#define ValuehorizCenter_DataStore_ELEMS() (1 * 1)
#define ValuehorizCenter_DataStore_ROWS() (1)
#define ValuehorizCenter_DataStore_COLS() (1)
#define ValuehorizCenter_DataStore()  (VolatileWork_BSS.ValuehorizCenter)

#define ValuevertCenter_DataStore_BYTES() (sizeof(ValuevertCenter_DataStore()))
#define ValuevertCenter_DataStore_ELEMS() (1 * 1)
#define ValuevertCenter_DataStore_ROWS() (1)
#define ValuevertCenter_DataStore_COLS() (1)
#define ValuevertCenter_DataStore()  (VolatileWork_BSS.ValuevertCenter)

#define Valuewrap_DataStore_BYTES() (sizeof(Valuewrap_DataStore()))
#define Valuewrap_DataStore_ELEMS() (1 * 1)
#define Valuewrap_DataStore_ROWS() (1)
#define Valuewrap_DataStore_COLS() (1)
#define Valuewrap_DataStore()  (VolatileWork_BSS.Valuewrap)

#define string_ov_ovr_DataStore_BYTES() (sizeof(string_ov_ovr_DataStore()))
#define string_ov_ovr_DataStore_ELEMS() (1 * 1)
#define string_ov_ovr_DataStore_ROWS() (1)
#define string_ov_ovr_DataStore_COLS() (1)
#define string_ov_ovr_DataStore()  (VolatileWork_BSS.string_ov_ovr)


    extern const Constant_T ConstantWork;

extern const NonVolatile_T NonVolatileDefault;

extern NonVolatile_T NonVolatileStorage;

extern NonVolatile_T NonVolatileWork;
        
#define NonVolatile_NonVolatileStatus_DataStore() (NonVolatile_NonVolatileStatus)
        
    /* DataStore */
extern Volatile_T VolatileWork;
extern Volatile_BSS_T VolatileWork_BSS;
extern uint8_T NonVolatile_NonVolatileStatus;
extern void NonVolatile_NonVolatileStatus_Reset(void);
extern void NonVolatile_RestoreDefaultNonVolatile(void);
extern void NonVolatile_StoreNonVolatile(void);
extern void NonVolatile_OpenNonVolatile(void);

#endif

